% Generate Random Noise

noiselfp = rand(1, 4001);
figure; 
hold; 
plot(linspace(0,2,4001),noiselfp);

% Filter Noise at 6-10 Hz

% Nyquist freq is half the sampling rate and represents
% the highest frequency the data can accurately represent
Nyquist_freq = 2000/2; 
low_freq = 6/Nyquist_freq; %lower freq bound
high_freq = 10/Nyquist_freq; %higher freq bound

filter_order = 3; % number of filter exponents
passband = [low_freq high_freq];
% Butterworth filter coefficients 
[Bc Ac] = butter(filter_order, passband); 
LFP_filt = filtfilt(Bc,Ac, noiselfp);
plot(linspace(0,2,4001), LFP_filt, 'Linewidth',2); 


% Label figure
legend('noise','filter');
title('Bandpass Filter');
xlabel('Time'); ylabel('Voltage');
hold off;

% Decompose filtered signal with a Fourier transform
y = fft(LFP_filt)/4001; %divide by num of samples
f = 2000/2 * linspace(0,1,4001/2 + 1);
figure; plot(f(1:40), abs(y(1:40)),'Linewidth',2);
title('Fast Fourier Transform'); 
xlabel('Frequency'); ylabel('Counts');




