% Signal Averaging Simulation 

% Generate 256 noisy trials 
trials = 256;
noise_trials = randn(256);

% Generate sine signal
sz = 1:trials;
sz = sz/(trials/2);
S = sin(2*pi*sz);

% Add noise to 256 sine signals
for i = 1:trials
    noise_trials(i,:) = noise_trials(i,:) + S;
end

% Average of 256 noisy signals
avg = sum(noise_trials)/trials;
odd_avg = sum(noise_trials(1:2:end,:)/(trials/2));
even_avg = sum(noise_trials(2:2:end,:)/(trials/2));
noise_estimate = odd_avg-even_avg;

% Create Figure
figure;
hold;
plot(noise_trials(1,:),'g');
plot(noise_estimate, 'k');
plot(avg,'r');
plot(S);
legend('noise trials','noise estimate','average','sine');
title('Signal Averaging', 'FontSize', 14);
xlabel('Time'); 
ylabel('Voltage');
xlim([0 260]);
hold off;




